/*
 * $Header: /nfs/bianca/mud/dist/src_new/clib/RCS/efun.c,v 1.2 1993/07/11 18:56:38 jacob Exp jacob $
 */

static char rcsid[] = "$Id: efun.c,v 1.2 1993/07/11 18:56:38 jacob Exp jacob $";

/*
 * $Log: efun.c,v $
 * Revision 1.2  1993/07/11  18:56:38  jacob
 * Fixed the warnings.
 *
 * Revision 1.1  1993/06/25  01:12:17  plugh
 * Initial revision
 *
 */

#include <stdio.h>
#include "../lint.h"
#include "../interface.h"
#include "../object.h"
/* Define variables */
extern struct object *previous_ob;


/* Define functions */

static void
efun_tell_room(struct svalue *fp)
{
    struct object *room = 0, *ob, *tp;
    struct svalue *oblist, *vv;
    int i, dont_print, size;
    
    push_number(0);

    if (command_giver && !(command_giver->flags & O_DESTRUCTED))
	tp=command_giver;
    else tp=0;
    
    if (fp[0].type == T_STRING)
	room = find_object2(fp[0].u.string);
    else if (fp[0].type == T_OBJECT)
	room = fp[0].u.ob;
    if (!room)
       return;
    switch (fp[2].type)
    {
    case T_OBJECT:
	size = 1;
	oblist = &fp[2];
	break;
    case T_POINTER:
	size = fp[2].u.vec->size;
	oblist = fp[2].u.vec->item;
	break;
    default:
	size = 0;
	break;
    }

    /* tell folx in room */
    for(ob = room->contains; ob; ob = ob->next_inv)
    {
	dont_print = 0;
	for (i = 0; i < size; i++)
	    if (oblist[i].u.ob == ob)
	       dont_print = 1;
	if (dont_print)
	   continue;
	/* before we push, check if it's a living */
	if (ob->flags & O_ENABLE_COMMANDS)
	   {
	   push_svalue(&fp[1]);
	   push_object(tp); 
	   apply("catch_msg", ob, 2, 0); 
	}
    }

    /* tell room */
    dont_print = 0; ob=room;
    for (i = 0; i < size; i++)
       if (oblist[i].u.ob == ob)
          dont_print = 1;
    if ((ob->flags & O_ENABLE_COMMANDS) && !dont_print)
    {
       push_svalue(&fp[1]);
       push_object(tp); 
       apply("catch_msg", ob, 2, 0); 
    }
}


static func func_tell_room = 
{
    "tell_room",
    efun_tell_room,
};

static void
efun_write(struct svalue *fp)
{
    push_number(0);

    if (!command_giver)
    {
	if (fp[0].type == T_STRING)
	printf("%s", fp[0].u.string);
	return;
    }
    push_svalue(fp);
    apply("catch_tell", command_giver, 1, 0);
}
static func func_write = 
{
    "write",
    efun_write,
 };


static void
efun_say(struct svalue *fp)
{
    struct object *tp, *ob;
    struct svalue *oblist,
           tp_svalue;      /* new */

    int size, i;
    int dont_print;

    push_number(0);
    
    if (command_giver && !(command_giver->flags & O_DESTRUCTED))
	tp=command_giver;
    else tp=0;

    tp_svalue.type=T_OBJECT; 
    tp_svalue.u.ob=tp;    
    
    switch (fp[1].type)
    {
    case T_OBJECT:
	size = 1;
	oblist = &fp[1];
	break;
    case T_POINTER:
	size = fp[1].u.vec->size;
	oblist = fp[1].u.vec->item;
	break;
    default:
	if (tp){
	   size = 1;
	   oblist = &tp_svalue;
	}
	else size=0;
	break;
    }

    /* tell folx in room */
    for (ob = tp->super->contains; ob; ob = ob->next_inv)
    {
	dont_print = 0;
	for (i = 0; i < size; i++)
	    if (oblist[i].u.ob == ob)
		dont_print = 1;
	if (dont_print)
	   continue;
	/* before we push, check if it's a living */
	if (ob->flags & O_ENABLE_COMMANDS)
	{
	   push_svalue(fp);
	   push_svalue(&tp_svalue); 
	   apply("catch_msg", ob, 2, 0); 
	}
    }

    /* tell room */
    dont_print = 0; ob = tp->super;
    for (i = 0; i < size; i++)
       if (oblist[i].u.ob == ob)
	  dont_print = 1;
    if ((ob->flags & O_ENABLE_COMMANDS) && !dont_print)
    {
       push_svalue(fp);
       push_svalue(&tp_svalue); 
       apply("catch_msg", ob, 2, 0); 
    }
    
    /* tell folx in player */
    for (ob = tp->contains; ob; ob = ob->next_inv)
    {
	dont_print = 0;
	for (i = 0; i < size; i++)
	    if (oblist[i].u.ob == ob)
		dont_print = 1;
	if (dont_print)
	   continue;
	/* before we push, check if it's a living */
	if (ob->flags & O_ENABLE_COMMANDS)
	{
	   push_svalue(fp);
	   push_svalue(&tp_svalue);
	   apply("catch_msg", ob, 2, 0);
	}
    }

    /* tell this_player */
    dont_print = 0; ob = tp;
    for (i = 0; i < size; i++)
       if (oblist[i].u.ob == ob)
	  dont_print = 1;
    if ((ob->flags & O_ENABLE_COMMANDS) && !dont_print)
    {
       push_svalue(fp);
       push_svalue(&tp_svalue); 
       apply("catch_msg", ob, 2, 0); 
    }   
}

static func func_say = 
{
    "say",
    efun_say,
};

static void
efun_fixnorm(struct svalue *fp)
{
    int offence, defence, result;
  
    if (fp[0].type == T_NUMBER)
        offence = fp[0].u.number;
    else
    {
        push_number(0);
        return;
    }
    if (fp[1].type == T_NUMBER)
        defence = fp[1].u.number;
    else
    {
        push_number(0);
        return;
    }
    if (offence + defence == 0)
    {
        push_number(0);
        return;
    }

    result = ((100 * offence)/(offence + defence)) - 50;
    push_number(result);
    return;
}

static func func_fixnorm = 
{
    "fixnorm",
    efun_fixnorm,
};


static void
efun_master_object(struct svalue *fp)
{
    extern struct object *master_ob;
    push_object(master_ob);
}
static func func_mo =
{
    "master_object",
    efun_master_object,
};

static void
efun_present_player(struct svalue *fp)
{
    struct object *ob;
    if (fp->type == T_OBJECT)
	for ( ob = fp->u.ob->contains; ob; ob = ob->next_inv)
	{
	    if (ob->interactive)
	    {
		push_number(1);
		return;
	    }
	}
    push_number(0);
}
static func func_pp =
{
    "present_player",
    efun_present_player,
};

static void
efun_present_living(struct svalue *fp)
{
    struct object *ob;
    if (fp->type == T_OBJECT)
	for ( ob = fp->u.ob->contains; ob; ob = ob->next_inv)
	{
	    if (ob->flags & O_ENABLE_COMMANDS)
	    {
		push_number(1);
		return;
	    }
	}
    push_number(0);
}
static func func_pl =
{
    "present_living",
    efun_present_living,
};

static void
efun_atoi(struct svalue *fp)
{
    if (fp->type == T_STRING)
	push_number(atoi(fp->u.string));
    else
	push_number(0);
}
static func func_atoi =
{
    "atoi",
    efun_atoi,
};

/* Define the interface */

static var *(vars[]) =
{
   0,
};

static func *(funcs[]) =
{
    &func_say,
    &func_write,
    &func_tell_room,
    &func_fixnorm,
    &func_mo,
    &func_pp,
    &func_pl,
    &func_atoi,
    0,
};


struct interface efun = 
{
    "secure/simul_efun.c",
    vars,
    funcs,
};
