#include <stdio.h>
#include <strings.h>
#include "../lint.h"
#include "../interface.h"
#include "../object.h"
/* Define variables */
extern struct object *previous_ob;


/* Define functions */

extern char *malloc(unsigned);

char lower(char c)
{
    char   ret;

    ret = c;
    if (ret < 96)
        ret += 32;
    return ret;
}

static void
global_article(struct svalue *fp)
{
    char    *tmp, *a;

    if (fp[0].type != T_STRING)
    {
        push_number(0);
	return;
    }
    tmp = malloc((strlen(fp[0].u.string)+10));
    strcpy(tmp, (char *)(fp[0].u.string));
    strcat(tmp," ");
    tmp[0] = (char)lower(tmp[0]);
    a      = malloc((strlen(fp[0].u.string)));
    if (sscanf((char *)tmp,"the %s",a)==1) 
    {
        push_string("", STRING_CONSTANT);
	free(tmp); free(a);
        return;
    }
    if (sscanf((char *)tmp,"a%s",a) == 1 || sscanf((char *)tmp,"e%s",a)== 1 ||
        sscanf((char *)tmp,"i%s",a) == 1 || sscanf((char *)tmp,"o%s",a)== 1 ||
        sscanf((char *)tmp,"u%s",a) == 1)
    {
        push_string("an", STRING_CONSTANT);
	free(tmp); free(a);
	return;
    }
    push_string("a", STRING_CONSTANT);
    free(tmp); free(a);
    return;
}

static func func_article = 
{
    "article",
    global_article,
};

static void
global_plural_word(struct svalue *fp)
{
    char *tmp, slask, *str, ch;
    int                     sl;
    
    if (fp[0].type == T_POINTER)
    {
        if (fp[0].u.vec[0].item[0].type != T_STRING)
	{
	    push_number(0);
	    return;
	}
        str = malloc((strlen(fp[0].u.vec[0].item[0].u.string)+1));
        strcpy(str, fp[0].u.vec[0].item[0].u.string);
    }
    else
    {
        str = malloc((strlen(fp[0].u.string)+1));
	strcpy(str, fp[0].u.string);
    }
    if (!str)
    {
        free(str);
	push_number(0);
	return;
    }
    if (strcmp(str, "tooth") == 0)
    {
	push_string("teeth",STRING_CONSTANT); free(str); return;
    }
    else if (strcmp(str, "foot") == 0)
    {
	push_string("feet",STRING_CONSTANT); free(str); return;
    }
    else if (strcmp(str, "man") == 0)
    {
	push_string("men",STRING_CONSTANT); free(str); return;
    }
    else if (strcmp(str, "woman") == 0)
    {
	push_string("women",STRING_CONSTANT); free(str); return;
    }
    else if (strcmp(str, "child") == 0)
    {
	push_string("children",STRING_CONSTANT); free(str); return;
    }
    else if (strcmp(str, "sheep") == 0)
    {
	push_string("sheep",STRING_CONSTANT); free(str); return;
    }
    else if (strcmp(str, "key") == 0)
    {
	push_string("keys",STRING_CONSTANT); free(str); return;
    }      
    sl = strlen(str) - 1;
    if (sl < 2)
    {
        push_string(str, STRING_MALLOC);
	free(str);
	return;
    }
    tmp = malloc((strlen((char *)str) + 10));
    ch = str[(sl)];
    strncpy(tmp, str, (sl-1));
    slask = str[(sl-1)];

    switch(ch)
    {
        case 's':
            tmp[(sl-1)] = slask;
	    tmp[sl]     = '\0';
	    strcat(tmp, "ses");
	    push_string(tmp, STRING_MALLOC);
	    free(str); free(tmp);
	    return;
        case 'x':
            tmp[(sl-1)] = slask;
	    tmp[sl]     = '\0';
	    strcat(tmp, "xes");
	    push_string(tmp, STRING_MALLOC);
	    free(str); free(tmp);
	    return;
        case 'y':
            tmp[(sl-1)] = slask;
	    tmp[sl]     = '\0';
	    strcat(tmp, "ies");
	    push_string(tmp, STRING_MALLOC);
	    free(str); free(tmp);
	    return;
        case 'h':
            tmp[sl-1] = slask;
	    tmp[sl] = '\0';
	    strcat(tmp, "hes");
	    push_string(tmp, STRING_MALLOC);
	    free(str); free(tmp);
	    return;
        case 'e':
            if (slask == 'f')
	    {
	        tmp[sl-1] = '\0';
	        strcat(tmp, "ves");
	        push_string(tmp, STRING_MALLOC);
	        free(str); free(tmp);
	        return;
	    }
	    break;
    }
    strcat(str, "s");
    push_string(str, STRING_MALLOC);
    free(str); free(tmp);
    return;
}

static func func_plural_word = 
{
    "plural_word",
    global_plural_word,
};


static func *(funcs[]) =
{
    &func_article,
    &func_plural_word,
    0,
};
static var *(vars[]) =
{
   0,
};

struct interface gllanguage = 
{
    "sys/global/language.c",
    vars,
    funcs,
};





