
#include <stdio.h>
#include "../lint.h"
#include "../interface.h"
#include "../object.h"
/* Define variables */
extern struct object *previous_ob;


/* Define functions */

extern char *malloc(unsigned);
static var obj_prev = { "obj_previous", 0, 0 };
static var obj_props = { "obj_props", 0, 0  };
static var obj_no_change = { "obj_no_change", 0, 0  };

/*
fp[0]: string to be expanded
fp[1]: target object
*/
static void 
object_check_call(struct svalue *fp)
{
    extern struct svalue const0;
    extern struct svalue *process_value (char *);
    extern char *process_string(char *);
    extern void new_call_out(struct object *, char *, int , struct svalue *);
    extern int remove_call_out(struct object *, char *);
    extern void INLINE push_malloced_string(char *p);
    extern struct object *query_simul_efun_ob();

    struct svalue *ret = 0, euid;
    char *a, *b, *str;
    int more;

    if (fp[0].type != T_STRING)
    {
	push_svalue(&fp[0]);
	return;
    }

    a = malloc(strlen(fp[0].u.string));
    b = malloc(strlen(fp[0].u.string));
    more = sscanf(fp[0].u.string, "@@%s@@%s", a, b);
    str = fp[0].u.string;

    push_object(current_object);
    ret = apply("geteuid", query_simul_efun_ob(), 1, 0);
    if (ret)
	assign_svalue_no_free(&euid, ret);
    ret = 0;
    
    push_number(0);
    apply("seteuid", current_object, 1, 0);

    new_call_out(current_object, "reset_euid", 1, 0);
    assign_svalue(&VAR(obj_prev), &fp[1]);

    if (more == 0 && str[0] == '@' && str[1] == '@')
	ret = process_value(&str[2]);
    else if (more == 1 || (more == 2 && !strlen(b)))
        ret = process_value(a);
    else if (more == 2)
        str = process_string(str);
    else if (sscanf(str, "%s@@%s", a, b) == 2)
    {
        str = process_string(str);
    }
    
    free(a);
    free(b);

    if (ret)
    {
	push_svalue(ret);
    }
    else
    {
	push_string(str, STRING_MALLOC);
    }

    push_svalue(&euid);
    apply("seteuid", current_object, 1, 0);
    free_svalue(&euid);

    assign_svalue(&VAR(obj_prev), &const0);
    remove_call_out(current_object, "reset_euid");
}

static func func_check_call = 
{
    "check_call",
    object_check_call,
};

static void
object_query_prop(struct svalue *fp)
{
    extern struct svalue *get_map_lvalue(struct mapping *,
					 struct svalue *, int );
    struct svalue *ret = 0;
    struct svalue *val;

    if (VAR(obj_props).type != T_MAPPING)
    {
	push_number(0);
	return;
    }
    push_svalue(get_map_lvalue(VAR(obj_props).u.map, fp, 0));
    ret = apply("check_call", current_object, 1, 0);
    if (ret)
    {
	push_svalue(ret);
    }
    else
    {
	push_number(0);
    }
}


static func func_query_prop = 
{
    "query_prop",
    object_query_prop,
};

static void
object_add_prop(struct svalue *fp)
{
   extern struct svalue *get_map_lvalue(struct mapping *,
					 struct svalue *, int );
   struct svalue *oval;

   if (VAR(obj_no_change).u.number || VAR(obj_props).type != T_MAPPING)
   {
      push_number(0);
      return;
   }

   assign_svalue((oval=get_map_lvalue(VAR(obj_props).u.map,fp,1)),&fp[1]);

   if (current_object->super)
   {
      push_svalue(&fp[0]);
      push_svalue(get_map_lvalue(VAR(obj_props).u.map,fp,0));
      push_svalue(oval);
      apply("notify_change_prop",current_object->super,3,0);
   }

   push_number(0);
   return;
}

static func func_add_prop = 
{
    "add_prop",
    object_add_prop,
};

static func func_change_prop = 
{
    "change_prop",
    object_add_prop,
};

/* Define the interface */
static var *(vars[]) =
{
    &obj_prev,
    &obj_props,
    &obj_no_change,
    0,
};

static func *(funcs[]) =
{
    &func_check_call,
    &func_query_prop,
    &func_add_prop,
    &func_change_prop,
    0,
};


struct interface stdobject = 
{
    "std/object.c",
    vars,
    funcs,
};

